<template>
	<div class="print_grid_style">
		<el-main>
			<div class="flex-content just-center">
				<h1 class="text-blue-color">Programación de la {{dateString}}</h1>
			</div>
			<div class="flex-content justify-content-center">
				<div>
					<div class="grid-schedule-title box_style_border_left width-50" ref="scrollSchedule">
						<div style="height: 31px"></div>
					</div>

					<div class="box_style box_style_border_left" style="grid-template-rows: 6px">
						<div style="grid-row:1/4" class="grid-schedule resize o-hidden">
							<p class="font-size-16"> 05:16 </p>
						</div>
						<div class="grid-schedule resize flex-content justify-content-center font-size-12" 
						v-for="(time, index) in timeForDay" :key="index" 
						:style="`grid-area: ${(6*  index) +4} / 1/ span 6 / 2`">
							<p class="font-size-16">{{ time }}</p>
						</div>
						<div class="grid-schedule resize o-hidden border-none" style="grid-row:286/289">
							<p class="font-size-16"> 05:00 </p>
				 		</div>
					</div>

					<div class="grid-schedule-title box_style_border_left">
						<div style="height: 31px"></div>
					</div>
				</div>

				<!--Content-->
				<div>
					<gridDays ref="scroll" :days="generateDays()" :sizeLetters="'font-size-18 d-flex flex-content justify-content-center'" :space="'pl-5'"/>

					<div class="grid-programs" ref="contenedor">
						<div v-for="(program, index) in orderByProgram" :key="index" class="grid-byProgram" :ref="`cell-${index}`" :class="[styleByDurationProgram(program.programPrincipal)]">
							<div class="flex justify position-z-index" v-if="durationProgram(program.programPrincipal) == 'font-size-12' || durationProgram(program.programPrincipal) == 'letters-normal' || durationProgram(program.programPrincipal) == 'font-size-20' || durationProgram(program.programPrincipal) == 'font-size-14' || durationProgram(program.programPrincipal) == 'font-size-14' || durationProgram(program.programPrincipal) == 'font-size-18' ">
								<div class="programDuration" :class="[durationProgram(program.programPrincipal) == 'font-size-12' ? 'font-size-12' : 'font-size-15' ]" >
									<span>{{calculateScheduleHours(program.programPrincipal.scheduleStartHour, program.programPrincipal.scheduleStartMin)}}</span>
									-
									<span>{{calculateScheduleHours(program.programPrincipal.scheduleEndHour, program.programPrincipal.scheduleEndMin)}}</span>
								</div>
							</div>

						<div class="work-break box_title" :class="[durationProgramResize(program.programPrincipal)]">
							<div :class="[ program.programPrincipal.stringMaterialType == 'Producción Nacional'? 'text-orange principalTitle' : 'text-blue-color principalTitle', styleTitlePrincipal(program.programPrincipal)]" v-if="program.programPrincipal.typeOfContent !== 'Largometrajes'">
                  				<span > {{ program.programPrincipal.programTitle }} </span>
                  
								<!-- TEMPORADA -->
								<span class="text-ligth blueColor principalTitle isTempYcodeFeatureFilm"> {{  verifySeason(program.programPrincipal.season, program.programByDay, program.programPrincipal.programTitle, program.programPrincipal ) }} </span>

								<!-- CLASIFICACION-->
								<span :class="[isClassificationFilmsShow(program.programPrincipal), (program.programPrincipal.materialType == 'Producción Nacional')?'text-marron':'text-red']"  class="padding-left-5" v-if="printView == 'promociones' && program.programPrincipal.classification !== ''">
									<span class="f-16">
										{{ isHaveContent(program.programPrincipal.classification)}}
									</span>
								</span>
							</div>
								
							<!-- Titulo del programa para largometrajes -->
							<div v-else>
								<p class="text-orange copyPrincipalTitle work-break;" >
									<span style="font-size: 10px"> "{{ program.programPrincipal.programTitle }}" </span> 
								<p>
								<p class="principalTitle text-blue-color work-break style_text_film"  >
                    				<span :class="[ printView == 'extranjero' ? 'f-16': 'size-letter']">  {{ program.programPrincipal.materialTitle }}  </span>
                   
									<!-- CLASIFICACION -->
                    				<span v-if="printView == 'promociones' || printView == 'intranet'  && program.programPrincipal.typeOfContent == 'Largometrajes'" :class="[isClassificationFilmsShow(program.programPrincipal), (program.programPrincipal.materialType == 'Producción Nacional')?'text-marron':'text-red']" class="padding-left-5">
										<span>{{ isHaveContent(program.programPrincipal.classification) }} </span>
						
										<span v-if="printView == 'promociones'"> 
											<span v-if="program.programByDay[0].chapters[0].rerun || program.programByDay[0].chapters     [0].estreno || program.programByDay[0].chapters[0].ongoing "> / </span>
										</span> 

										<span v-if="program.programByDay[0].chapters[0].rerun && printView == 'promociones'" class="text-red">Rerun </span>
										<span v-if="program.programByDay[0].chapters[0].estreno && printView == 'promociones'" class="text-red"> Estreno </span> 
										<span v-if="program.programByDay[0].chapters[0].ongoing && printView == 'promociones'" class="text-celeste"> (ONGOING) </span> 
                    				</span>
								</p>
							</div>

							<div class="principalTitle isTempYcodeFeatureFilm" v-if="printView == 'interno'">
								<div style="letter-spacing: -0.5px; font-weight: 100; font-size: 12px" class="text-blue" v-if="program.programPrincipal.codeFeatureFilm && program.programPrincipal.materialHasChapter == 'No' && program.programPrincipal.typeOfContent == 'Largometrajes' || program.programPrincipal.typeOfContent == 'LARGOMETRAJES' "> 
                    				<span> ({{ program.programPrincipal.codeFeatureFilm }}) </span>
								</div>
							</div>
							<!-- _________Nota general__________ -->
							<div v-if="program.programPrincipal.generalNote && program.programPrincipal.generalNote !== ''" class="flex-content justify-content-center general-note-style work-break text-center line-height-11" :class="[sizeTextGeneralNote(program)]" v-html="program.programPrincipal.generalNote"></div>
						</div>
              			<!-- validar para que solo entren los diferentes largometrajes -->
						<div class="boxAllDays p-absolute box_content" :class="[durationProgramResize(program.programPrincipal)]">
							<!-- tengo mas de un dia -->
							<div class="boxByDay" v-for="(day, index) in program.programByDay" :key="index" :style="`grid-column: ${index+1} / span 1; backgroundColor: ${day.bgColorByProgram}`" >
								<div class="contentBoxByChapter p-absolute">
									<div v-if="day.nota && day.nota !== ''" class="note note-style-middle line-height-9 text-color-note" v-html="day.nota"></div>
									<div v-if="day.noteDay && day.noteDay !== ''" class="note note-style-middle line-height-9 text-color-note" v-html="day.noteDay"></div>
      
									<div v-if="verificandoCantidadDeCapitulos(day.chapters, program.programByDay, program.programPrincipal.programTitle, program.programPrincipal)" >
										<!-- <div v-if="program.programPrincipal.typeOfContent == 'Largometrajes' || program.programPrincipal.typeOfContent == 'LARGOMETRAJES' || chapter.numChapter !== '' " class="boxByChapter flex-content justify-content-space" v-for="(chapter, i) in day.chapters" :key="i"> -->
										<div class="boxByChapter flex-content justify-content-space p-i-0 pb-i-2" v-for="(chapter, i) in day.chapters" :key="i">
											<div style="width: 100%; max-width: 100%;" class="boxDataByChapter">
												<!-- {{ program.programPrincipal.typeOfContent }} -->
												<div v-if="chapter.numChapter !== '' && chapter.numChapter !== null && printView == 'interno' || printView == 'promociones' && calculateTime(program.programPrincipal) > '00:30:00' && program.programPrincipal.typeOfContent !== 'Largometrajes' ">
													<!-- __________Estado___________ -->
													<span v-if="printView == 'interno'" style="font-size: 14px !important" class="padding-right-5 text-blue"  > {{chapter.numChapter}} </span>

                            						<span class="statusByChapterText" v-if="calculateTime(program.programPrincipal) > '00:30:00'"> 
														<span v-if="chapter.rerun" class="text-blue">Rerun </span> <span v-if="chapter.rerun && chapter.estreno">-</span>
														<span v-if="chapter.estreno" class="text-red"> Estreno </span> 
														<span v-if="chapter.ongoing" class="text-celeste"> (ONGOING) </span> 
													</span>
                          						</div>
											<!-- __________Actors___________ -->
											<div  v-if="isShowActors(program.programPrincipal)" :class="[ printView == 'extranjero' ? 'line-heigth-18': 'line-heigth-12']">
												<p :class="[ printView == 'extranjero' ? 'size-letter-12': 'size-letter-10']" class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px;"> {{ program.programPrincipal.firstActor }} </p>
												<p :class="[ printView == 'extranjero' ? 'size-letter-12': 'size-letter-10']"   class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px;"> {{ program.programPrincipal.secondActor }} </p>
											</div>
                        				</div>
                      				</div>
                    				</div>
       

                  					<div v-else class="boxByChapter flex-content justify-content-space" >
										<div style="width: 100%; max-width: 100%;" class="boxDataByChapter">
											<div>
                          						<span class="padding-right-5 text-blue ocupandoContenedor" v-if="printView == 'interno' && calculateTime(program.programPrincipal) > '00:30:00'" v-html="showChaptersInLine( day.chapters )" > </span> 
											</div>
											<!-- __________Actors___________ -->
											<div v-if="isShowActors(program.programPrincipal)" style="line-height: 12px">
												<p class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px; font-size: 10px"> {{ program.programPrincipal.firstActor }} </p>
                          						<p  class="text-blue-color" style="display: inline-block; font-weight: 400; margin-left: 8px; font-size: 10px"> {{ program.programPrincipal.secondActor }} </p>
											</div>
										</div>
									</div>
									</div>	
								</div>
							</div>
						</div>
					</div>
					<gridDays :days="generateDays()" :sizeLetters="'font-size-18 d-flex flex-content justify-content-center'" :space="'pl-5'"/>
				</div>

				<!--Schedule-->
				<div>
					<div>
						<div class="grid-schedule-title box_style_border_rigth width-50" ref="scrollSchedule">
							<div style="height: 31px"></div>
						</div>

						<div class="box_style box_style_border_rigth">
							<div class="grid-schedule resize o-hidden" style="grid-row:1/4"> 
								<p class="font-size-16"> 05:16 </p>
							</div>
							<div class="grid-schedule resize flex-content justify-content-center font-size-12" 
							v-for="(time, index) in timeForDay" :key="index" 
							:style="`grid-area: ${(6*  index) +4} / 1/ span 6 / 2`">
								<p class="font-size-16">{{ time }}</p>
							</div>
							<div class="grid-schedule resize o-hidden border-none" style="grid-row:286/289">
								<p class="font-size-16"> 05:00 </p>
							</div>
						</div>

						<div class="grid-schedule-title box_style_border_rigth">
							<div style="height: 31px"></div>
						</div>
					</div>
				</div>

			</div>
		</el-main>

	</div>
</template>

<script>
import ReturnButton from '@/components/ReturnButton.vue'
import ModalContentComponent from './components/ModalContent'
import gridDays from '@/components/grid/gridDays'
import Title from '@/components/Title.vue'
import { sizeLetttersAboutProgram, calculateSchedule } from '@/utils/calculateSizeLetters.js'
import { getFirstDay } from '@/utils/calculateTime.js'
import { HTTP } from '@/main.js'
import { addingZerosToTheDay} from '@/utils/calculateTimePrograms.js'

export default {
	components: {
		'app-title': Title,
		ModalContentComponent,
		ReturnButton,
		gridDays
	},
	data () {
		return {
			dataTable: '',
			dateSearch: '',
			firstDayOfWeek: '',
			firstDay: JSON.parse(sessionStorage.getItem('firstDay')) ,
			secondDay: JSON.parse(sessionStorage.getItem('secondDay')) ,
			thirdDay: JSON.parse(sessionStorage.getItem('thirdDay')) ,
			fourthDay: JSON.parse(sessionStorage.getItem('fourthDay')) ,
			fifthDay: JSON.parse(sessionStorage.getItem('fifthDay')) ,
			sixthDay: JSON.parse(sessionStorage.getItem('sixthDay')) ,
			lastDay: JSON.parse(sessionStorage.getItem('lastDay')) ,
			month: '',
			month2: '',
			year: '',
			year2: '',
			startDate: '',
			endDate: '',
			orderByProgram: [],
			// orderByProgram: JSON.parse(sessionStorage.getItem('orderByProgram')) ,
			idOfPrograms: [],
			hour: 5,
			minute: 0,
			contentHtml: '',
			dateString: JSON.parse(sessionStorage.getItem('dateString')),
			modalInfo: false,
			programSelected: {},
			transmission: [],
			allDiasByProgram: [],
			timeForDay: [],
			isSelectColor: false,
			checkAllDays: [],
			changeStatus: '',
			clasificationColor: '',
			notShowSchedule: false,
			dataAllWeek: [],
			allProgramsWithGrid: JSON.parse(sessionStorage.getItem('allProgramsWithGrid')),
			chanelTransmission: this.$localStorage.get('channelTransmition'),
			printView: this.$route.params.grid
		}
	},
	mounted(){
		let alturas = []
		for(let i=1; i<=288; i++){alturas.push['6px']};
		let templateRows = alturas.join(' ');
		const items = document.querySelectorAll('.grid-schedule');
		const boxes = document.querySelectorAll('.box_style');
		const grids = document.querySelectorAll('.grid-programs')
		boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
		grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)		

		window.addEventListener('mouseup',()=>{
			items.forEach(item=>{
				let style = item.getAttribute('style').split(';');
				item.setAttribute('style',style[0])
			})
		})

		var ro = new ResizeObserver( entries => {
			for (let entry of entries) {
				const cr = entry.contentRect;
				const hg = parseInt(cr.height);
				let maxIndex = 6;
				let gridLine = parseInt(entry.target.style.gridRow);
				let divBorder = gridLine==286? 0:3;				
				maxIndex = gridLine==1 || gridLine==286 ? 3:6
				let calculateHeigth = Math.floor((Math.floor(hg)+divBorder)/maxIndex)
				for(let j=gridLine -1; j<= gridLine+maxIndex-2; j++){
					alturas[j]= calculateHeigth+'px';
				}
				templateRows = alturas.join(' ');
				boxes.forEach(box=>box.style.gridTemplateRows = templateRows)
				grids.forEach(grid=>grid.style.gridTemplateRows = templateRows)
			}
		});

		items.forEach(item=>ro.observe(item))
	},
	methods: {
    showChaptersInLine ( arrayChapters ) {
      let chapters = ''
      arrayChapters.map((chap, i, arr) => {
        let statusRerun = chap.rerun && chap.rerun !== '' ? `<span class="text-blue"> RERUN </span>` : false
        let statusEstreno = chap.estreno && chap.estreno !== '' ? `<span class="text-red"> ESTRENO </span> ` : false
        let statusOngoing = chap.ongoing && chap.ongoing !== '' ? ` <span class="text-celeste"> (ONGOING) </span>` : false

        if (i == (arr.length - 1 )) {
          if (statusRerun ||  statusEstreno || statusOngoing ) {
            if (statusRerun &&  statusEstreno && statusOngoing ) {
              chapters += `${chap.numChapter} ${statusRerun} ${statusEstreno} ${statusOngoing}  ` 
            }
            else if (statusRerun &&  statusEstreno ) {
              chapters += `${chap.numChapter} ${statusRerun} ${statusEstreno}  ` 
            }
            else if (statusEstreno && statusOngoing) {
              chapters += `${chap.numChapter} ${statusEstreno} ${statusOngoing}  ` 
            }
            else if (statusRerun && statusOngoing ) {
              chapters += `${chap.numChapter} ${statusRerun} ${statusOngoing}  ` 
            }
            else if (statusRerun) {
              chapters += `${chap.numChapter} ${statusRerun}   ` 
            }
            else if (statusEstreno) {
              chapters += `${chap.numChapter} ${statusEstreno}   ` 
            }
            else if (statusOngoing) {
               chapters += `${chap.numChapter} ${statusOngoing}   ` 
            }
          }
          else {
            chapters += `${chap.numChapter}   ` 
          }
        }
        else {
          if (statusRerun ||  statusEstreno || statusOngoing ) {
            if (statusRerun &&  statusEstreno && statusOngoing ) {
              chapters += `${chap.numChapter} ${statusRerun} ${statusEstreno} ${statusOngoing};   ` 
            }
            else if (statusRerun &&  statusEstreno ) {
              chapters += `${chap.numChapter} ${statusRerun} ${statusEstreno};  ` 
            }
            else if (statusEstreno && statusOngoing) {
              chapters += `${chap.numChapter} ${statusEstreno} ${statusOngoing};   ` 
            }
            else if (statusRerun && statusOngoing ) {
              chapters += `${chap.numChapter} ${statusRerun} ${statusOngoing};   ` 
            }
            else if (statusRerun) {
              chapters += `${chap.numChapter} ${statusRerun};   ` 
            }
            else if (statusEstreno) {
              chapters += `${chap.numChapter} ${statusEstreno};   ` 
               
            }
            else if (statusOngoing) {
              chapters += `${chap.numChapter} ${statusOngoing};   ` 
            }
          }
          else {
           chapters += `${chap.numChapter};   `

          }
        }
        let onlyText = chapters.replace(/<[^>]*>?/g, '')

        if (onlyText.length > 20 && onlyText.length < 30) {
          chapters += `<br>`

        }
      })
      return chapters
    },
    verificandoCantidadDeCapitulos (arrayDeCap, arrayByDay,  titleProgram, infoProgramPrincipal) {
      const durationProgram = this.calculateTime(infoProgramPrincipal)
      const diasAtransmitir = arrayByDay.length
      const numeroDePalabrasTitulo = titleProgram.length
      const cantCap = arrayDeCap.length
      if (diasAtransmitir > 1 && durationProgram >=  '01:00:00' && cantCap > 3 ) {
        return false
      }
      else if (durationProgram <  '01:00:00' && cantCap > 1 ) {
        return false
      }
      else if (diasAtransmitir == 1 && cantCap >= 3 ) {
        return false
      }
      else {
        return true
      }
    },
    verifySeason (season, arrayByDay, titleProgram, infoProgramPrincipal ) {
      if (season !== '' && season !== null ) {
        const durationProgram = this.calculateTime(infoProgramPrincipal)
        const diasAtransmitir = arrayByDay.length
        const numeroDePalabrasTitulo = titleProgram.length
        let descriptionSeason
  
        if ( durationProgram <=  '01:00:00' && diasAtransmitir < 2 ) {
          descriptionSeason = `(${season}° TEMP)`
        }
        else {
         descriptionSeason =  `(${season}° TEMPORADA)`
        }
        return  descriptionSeason

      }
      else {
        return null
      }
    },
		generateDays() {
			const days = [
				{
					name: 'Lunes',
					number: addingZerosToTheDay(this.firstDay),
				},
				{
					name: 'Martes',
					number: addingZerosToTheDay(this.secondDay),
				},
				{
					name: 'Miercoles',
					number: addingZerosToTheDay(this.thirdDay),
				},
				{
					name: 'Jueves',
					number: addingZerosToTheDay(this.fourthDay),
				},
				{
					name: 'Viernes',
					number: addingZerosToTheDay(this.fifthDay),
				},
				{
					name: 'Sábado',
					number: addingZerosToTheDay(this.sixthDay),
				},
				{
					name: 'Domingo',
					number: addingZerosToTheDay(this.lastDay),
				}
			]
			return days
		},
		conditionalDurationProgram(value) {
			let conditional = this.styleByDurationProgram(value)
			console.log(conditional, 'c')
			if(conditional == 'program_normal') {
				return true
			} else {
				return false
			}
		},
		isLargometraje(value) {
			if(value == 'Largometrajes' || value == 'LARGOMETRAJES') {
				return true
			} else {
				return false
			}
			// program.programPrincipal.typeOfContent == 'Largometrajes' || program.programPrincipal.typeOfContent == 'LARGOMETRAJES'
		},
		isHaveContent(val) {	
			let value
			if(val && val !== '') {
				value = `(${val})`
			} else {
				value = ''
			}
			return value
		},
		isClassificationFilmsShow(val) {
			const data = this.calculateTime(val)
			return data >= '01:00:00' ? 'textCollapse' : 'd-inline-block'
		},
		openModal(program) {   
			this.programSelected = program.programPrincipal
			this.allDiasByProgram = program.programByDay
			this.modalInfo = true
		},
		closeModal() {
			this.modalInfo = false
		},
		addClassToProgramTitle (program) {
			let hasChapters = false
			if(!(program.programByDay.length > 1)){
				if(!(program.programByDay[0].material.numChapters.length > 0)){
					hasChapters = true
				}
			}
			return hasChapters
		},
		handleScroll (event) {
		  let sticky = this.$refs.scroll
			if (window.pageYOffset >= 300) {
				sticky.classList.add("sticky")
			} else {
				sticky.classList.remove("sticky");
			}

			let stickySchedule = this.$refs.scrollSchedule
			if (window.pageYOffset >= 300) {
				stickySchedule.classList.add("sticky")
			} else {
				stickySchedule.classList.remove("sticky");
			}

			let stickyScheduleRight = this.$refs.scrollScheduleRight
			if (window.pageYOffset >= 300) {
				stickyScheduleRight.classList.add("sticky")
			} else {
				stickyScheduleRight.classList.remove("sticky");
			}
    	},
		returnPage () {
    	this.$router.push({ name: 'views'})
		},
		getWeek (week) {
			let res = this.allProgramsWithGrid
			console.log(res, 'res')
			this.orderByProgram = []
			this.idOfPrograms = []
			// const responseText = 'Week not found'
			const responseText = "Week not found weekDate"
			// const {weekDate} = this.allProgramsWithGrid
			if(res !== responseText) {
				console.log( 'holaaa')
				// this.dataAllWeek = weekDate
				const {programs} = res.length > 0 ? res[0] : res
				// FILTRO POR CANAL DE TRANSMISION
				let isTrue = false
				let programsByChannel = []
				programs.map((program)=>{
					if(program.refProgram.checkedChanels.length > 0){
						program.refProgram.checkedChanels.map((channel)=> {
							if(channel.toLowerCase() == this.chanelTransmission.toLowerCase()){
								programsByChannel.push(program)
							}
						})
					} else {
						programsByChannel.push(program)
					}
				})

				// RECORRE LA DATA QUE TRAE LA RESPUESTA
				programsByChannel.map((program)=>{
					const {refProgram: {_id}} = program

					const object = {
						programPrincipal: this.modelPrincipalProgram(program),
						programByDay: [this.modelProgramByDay(program)]
					}

					if(this.idOfPrograms.includes(_id) == false){
						// INSERTA LOS PROGRAMAS SI SUS ID'S NO HAN SIDO INSERTADOS ANTERIORMENTE
						this.idOfPrograms.push(_id)
						this.orderByProgram.push(object)
					} else {
						const {refProgram: {codeDays}} = program

						let arrSamePrograms = []
						this.orderByProgram.map((program, index)=>{
							if(program.programPrincipal._id == _id){
								arrSamePrograms.push(index)
							}
						})
						
						let daySelected = this.getDayCode(program.completeDate)
						
						let addToProgram = false
						//RECORRE EL ARRAY DE PROGRAMAS QUE SE HAN CREADO PERO QUE PERTENECEN AL MISMO PROGRAMA
						for(let i=0; i<arrSamePrograms.length; i++){
							let programSelected = this.orderByProgram[arrSamePrograms[i]]
							let daysSaved = []
							//GUARDA EN UN ARRAY LOS DIAS QUE SE HAN GUARDADO EN EL PROGRAMA
							programSelected.programByDay.map((programDay)=>{
								const day = programDay.completeDate
								const daySaved = this.getDayCode(day)
								daysSaved.push(daySaved)
							})
							
							//RECORRE LOS DIAS DEL PROGRAMA 
							codeDays.map((day, index)=>{
								//VERIFICA EL DIA SELECCIONADO
								if(day == daySelected){
									//SI ES DOMINGO SE CAMBIA A 8 PORQUE CON EL 1 NO VALIDA CORRECTAMENTE
									daySelected = (daySelected == 1)? 8: daySelected
									//VALIDA SI EL DIA SELECCIONADO ES CORRELATIVO EN EL ARRAY DE DIAS DEL PROGRAMA
									if(codeDays.includes(daySelected-1) || codeDays.includes(daySelected+1)){
										//RECORRE LOS DIAS DEL PROGRAMA YA INGRESADOS
										daysSaved.map((savedDay)=>{
											//VERIFICA QUE EL DIA SELECCIONADO SEA CORRELATIVO A LOS DIAS QUE YA ESTAN INGRESADOS
											if(savedDay == (daySelected-1) || savedDay ==  (daySelected+1)){
												// VERIFICA QUE LOS DIAS CONTENGAN EL MISMO HORARIO
												const indexArrProgram = programSelected.programByDay.length -1
												const lastProgram = programSelected.programByDay[indexArrProgram]
												const programByDay = this.modelProgramByDay(program)
												
												let lastProgramTimeStart = this.convertToMinutes(lastProgram.scheduleStartHour, lastProgram.scheduleStartMin)
												let lastProgramTimeEnd = this.convertToMinutes(lastProgram.scheduleEndHour, lastProgram.scheduleEndMin)

												let programSelectedTimeStart = this.convertToMinutes(programByDay.scheduleStartHour, programByDay.scheduleStartMin)
												let programSelectedTimeEnd = this.convertToMinutes(programByDay.scheduleEndHour, programByDay.scheduleEndMin)

												if((lastProgramTimeStart == programSelectedTimeStart) && (lastProgramTimeEnd == programSelectedTimeEnd)){
													addToProgram = true
													programSelected.programByDay.push(this.modelProgramByDay(program))
												} else {
													addToProgram = false
												}
												
											}
										})
									}
								}
							})
						}

						//AGREGA COMO NUEVO PROGRAMA SI NO ES UN DIA CORRELATIVO
						if(addToProgram == false){
							this.orderByProgram.push(object)
						}

					}
				})
			}
				
			this.orderByProgram = this.sortByHour(this.orderByProgram)
			this.fillingGrid(this.orderByProgram)
		},
		modelProgramByDay(program) {
			const programByDay = {
				chapters: program.chapters,
				dailyCuttingProgram: program.dailyCuttingProgram,
				crushedPrograms: program.crushedPrograms,
				replacementPrograms: program.replacementPrograms,
				isShowTemporadas: program.isShowTemporadas,
				programGridTitle: program.programGridTitle,
				dailyProgramDate: program.dailyProgramDate,
				completeDate: program.completeDate,
				scheduleStartHour: program.scheduleStartHour,
				scheduleStartMin: program.scheduleStartMin,
				scheduleEndHour: program.scheduleEndHour,
				scheduleEndMin: program.scheduleEndMin,
				materialTitle: program.materialTitle,
				codMaterial: program.codMaterial,
				material: program.material,
				refProgram: program.refProgram,
				materialReferencia: program.materialReferencia,        
				programDate: program.programDate,
				geminisCodeProgram: program.geminisCodeProgram,
				IsCap: program.IsCap,
				EstTemp: program.EstTemp,
				Estado: program.Estado,
				bgColorByProgram: program.bgColorByProgram,
				chapterColor: program.chapterColor,
				seasonStateColor: program.seasonStateColor,
				stateChapterColor: program.stateChapterColor,
				rerunChapterColor: program.rerunChapterColor,
				nota: program.nota,
				isUnitPrice: program.isUnitPrice,
				unitPriceColor: program.unitPriceColor,
				IsCodProvider: program.IsCodProvider,
				codProviderColor: program.codProviderColor,
				IsPricePass: program.IsPricePass,
				pricePassColor: program.pricePassColor,
				generalNote: program.generalNote
      		}
			return programByDay
		},
		modelPrincipalProgram(program){
			const programPrincipal = {
				_id: program.refProgram._id,
				arrCheckCrosses: program.refProgram.arrCheckCrosses,
				checkedChanels: program.refProgram.checkedChanels,
				checkedSignals:program.refProgram.checkedSignals ,
				codProgram: program.refProgram.codProgram,
				codeDays: program.refProgram.codeDays,
				geminisCode: program.refProgram.geminisCode,
				programTitle: program.refProgram.programTitle,
				scheduleEndHour: program.scheduleEndHour,
				scheduleEndMin: program.scheduleEndMin,
				scheduleStartHour: program.scheduleStartHour,
				scheduleStartMin: program.scheduleStartMin,
				transmissionDays: program.refProgram.transmissionDays,
				classification: program.classification,
				isTemporada: program.isTemporada,
				isClasification: program.isClasification,
				clasificationColor: program.clasificationColor,
				seasonColor: program.seasonColor,
				isUnitPrice: program.isUnitPrice,
				unitPriceColor: program.unitPriceColor,
				generalNote: program.generalNote,
				IsCodProvider: program.IsCodProvider,
				providerCode: program.providerCode,
				transmissionDaysDescription: this.dayStartAndDayEnd(program.refProgram.transmissionDays),
				typeOfContent: program.typeOfContent,
				materialTitle: program.materialTitle,
				materialHasChapter: program.materialHasChapter,
				materialType: program.materialType,
				firstActor: program.firstActor,
				secondActor: program.secondActor,
				unitPrice: program.unitPrice,
				season: program.season,
				stringMaterialType: program.stringMaterialType,
				codeFeatureFilm: program.codeFeatureFilm
			}
			return programPrincipal
		},
		convertToMinutes(hours, minutes){
			const result = (hours * 60) + minutes
			return result
		},
		sortByHour(programs) {
			return programs.slice().sort(function(a, b) {
				//SE ORDENA POR TOTAL DE MINUTOS
				const firstProgramMinutesTotal = (a.programPrincipal.scheduleStartHour * 60) + a.programPrincipal.scheduleStartMin
				const secondProgramMinutesTotal = (b.programPrincipal.scheduleStartHour * 60) + b.programPrincipal.scheduleStartMin
				
				return firstProgramMinutesTotal - secondProgramMinutesTotal;
			});
		},
		getDayCode (day){
			let daySelected = day.split(' ')[0]
			let dayCode = ''
			switch(daySelected){
				case 'Lunes':
					dayCode = 2
				break;
				case 'Martes':
					dayCode = 3
				break;
				case 'Miércoles':
					dayCode = 4
				break;
				case 'Jueves':
					dayCode = 5
				break;
				case 'Viernes':
					dayCode = 6
				break;
				case 'Sábado':
					dayCode = 7
				break;
				case 'Domingo':
					dayCode = 1
				break;
			}

			return dayCode
		},
	  fillingGrid (data) {
			let programs = data
			this.contentHtml = ''
			programs.map((program, index) => {
				let template = ''
				const nameProgram = program.programPrincipal.programTitle	
				const arrDays = program.programByDay.map((e)=> (this.getDayCode(e.completeDate) == 1)?8:this.getDayCode(e.completeDate))

				const daysInOrder = arrDays.sort()

				let hourStart = program.programPrincipal.scheduleStartHour
				let hourEnd = program.programPrincipal.scheduleEndHour
				let minEnd = program.programPrincipal.scheduleEndMin
	      let minStart = program.programPrincipal.scheduleStartMin

        if (hourStart <5 ) {
          hourStart = Number(hourStart) + 24
        }
        else if (hourStart == 5 && hourEnd !== 5 && minStart != 16 && minEnd == 16 ) {
          hourStart = Number(hourEnd) + 24
        }
        
        if (hourEnd <5) {
          hourEnd = Number(hourEnd) + 24
        } 
        else if (hourEnd == 5 && minEnd<=16) {
          hourEnd = Number(hourEnd) + 24
        }

        const totalMinutesStart = (Number(hourStart)*60) + Number(program.programPrincipal.scheduleStartMin)
				const totalMinutesEnd = (Number(hourEnd)*60) + Number(minEnd)
        
				let initGrid = Math.round(totalMinutesStart/5 - 63.2 )
				let finalGrid = Math.round(totalMinutesEnd/5 - 63.2 )
				const concatGrid = (initGrid+1) +' / '+ (daysInOrder[0]-1) + ' / span '+ (finalGrid - initGrid) + ' / ' + (daysInOrder[(daysInOrder.length)-1])

				template = `<div class="grid-programsByDay" style="grid-area: ${concatGrid};">
								${nameProgram}
							</div>`
				this.contentHtml += template

				let divObj = 'cell-'+index
				this.$refs[divObj] && this.$refs[divObj][0] ? this.$refs[divObj][0].style.gridArea = concatGrid : ''
			})
		},
		dayStartAndDayEnd(val) {
			if(val && val.length > 1) {
				const counter = val.length
				const connect = val[0] == 'Lunes' ? 'a' : 'y'
				const counterCondicional = connect == 'a' ? 5 : 2
				const text = `${val[0]} ${connect} ${val[counter-1]}`
				return {
					text,
					value: counterCondicional
				}
			} else if(val && val.length == 1) {
				return {
					text: val[0],
					value: 1
				}
			}
		},
		/*___________________Métodos para crear el array de las horas ____________________*/
		getTime(firstTime, secondTime, operator) {
			const secs1 = this.stringToSeconds(firstTime)
			const secs2 = this.stringToSeconds(secondTime)
			let secsDif
			if(operator == 'sum') {
				secsDif = secs1 + secs2
			} else {
				if(secs1 > secs2) {
					secsDif = secs1 - secs2
				} else {
					secsDif = secs2 - secs1
				}
			}
			return this.secondsToTime(secsDif)
    	},
		stringToSeconds(tiempo) {
			let sep1 = tiempo.indexOf(":")
			let sep2 = tiempo.lastIndexOf(":")
			let hor = tiempo.substr(0, sep1)
			let min = tiempo.substr(sep1 + 1, sep2 - sep1 - 1)
			return Number(min) * 60 + Number(hor) * 3600
		},
		secondsToTime(secs) {
			let hor = Math.floor(secs / 3600)
			let min = Math.floor((secs - hor * 3600) / 60)
			let sec = secs - hor * 3600 - min * 60
			// return this.padNmb(hor, 2) + ":" + this.padNmb(min, 2)
			return (
				this.padNmb(hor, 2) +
				":" +
				this.padNmb(min, 2) +
				":" +
				this.padNmb(sec, 2)
			)
		},
		padNmb(nStr, nLen) {
			const sRes = String(nStr)
			const sCeros = "0000000000"
			return sCeros.substr(0, nLen - sRes.length) + sRes
		},
		recordArray(firstTime, secondTime, operator, record) {
			const arr = [firstTime]
			for (let i = 0; i < record; i++) {
				arr.push(this.getTime(arr[i], secondTime, operator));
			}
			return arr
		},
		formatedArray() {
			const b = this.recordArray("05:30:00", "00:30:00", 'sum', 36).concat(this.recordArray("00:00:00", "00:30:00", 'sum', 9 ))
			const d = b.map((e) => e.slice(0, 5))
			return d
		},
		isHaveContent(val) {
			let value
			if(val) {
				value = `(${val})`
			} else {
				value = ''
			}
			return value
		},
		noteDiv(classAsigned, nota) {
			const reviewClass = classAsigned.replace('el-textarea__inner', '') 
			const classSelect = reviewClass.replace('textarea-style', '')
			const template = nota && nota !== ''? `<div><p class="${classSelect}">${nota}</p></div>` : ''
			return template
		},
		isHaveActors(val) {
			let value, arr
			if(val && val.artisticInfo) {
				let exitsActors = val.artisticInfo.length > 0 ? val.artisticInfo[0].mainActors : []
				let counterActors = exitsActors.length
				if(counterActors > 2) {
					arr = [exitsActors[0], exitsActors[1]]
				} else {
					arr = exitsActors
				}
				value = arr
			}
			return value
		},
		calculateScheduleHours(scheduleStartHour, scheduleStartMin) {
			return calculateSchedule(scheduleStartHour, scheduleStartMin)
		},
		calculateTime(val) {
			const {scheduleStartHour, scheduleStartMin, scheduleEndHour, scheduleEndMin} = val
			const dateStart = calculateSchedule(scheduleStartHour, scheduleStartMin)
			const dateEnd = calculateSchedule(scheduleEndHour, scheduleEndMin)
			const data = this.getTime(this.conditionalDate(dateEnd), this.conditionalDate(dateStart), 'min')
			return data
		},
		conditionalDate(val) {
			let getTime = val.split(":")
			let getHour = String(getTime[0])
			let hour = this.calculateHour(getHour)
			let getMin = String(getTime[1])
			let min = this.calculateHour(getMin)
			let conditionalHour = hour === '00' ? '24' : hour
			let time = `${conditionalHour}:${min}:00`
			return time
		},
		calculateHour(hour) {
			return hour.length >= 2 ? hour : `0${hour}`
		},
		styleTitlePrincipal (val) {
			const {programTitle} = val
			const data = this.calculateTime(val)
			let time
			if(data <= '00:05:00') {
				time = 'letters-small font-size-8 font-weight-0 m-0'
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-8 font-weight-0', 'font-size-11 font-weight-0 m-0')
      }
       else if(data > '00:15:00' && data <= '00:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-10 font-weight-0 ', 'font-size-12 font-weight-0  m-0')
      } 
      //  else if(data > '00:30:00' && data <= '01:00:00') {
			// 	time = sizeLetttersAboutProgram(programTitle, 'font-size-14 font-weight-0', 'font-size-14 m-0')
      // }
      else if ( this.printView == 'extranjero' ) {
        time = 'f-16 font-weight-0'
      }
       else {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-14 m-0 w-100 p-0', 'font-size-14 m-0')
      } 
      // else {
			// 	time = 'font-size-18 m-0 w-100 p-0', 'font-size-20 m-0'
			// }
			return time
		},
		durationProgram(val) {
			const {programTitle, typeOfContent, codeFeatureFilm, materialTitle} = val
			const data = this.calculateTime(val)
			let conditional = this.isLargometraje(typeOfContent)
			codeFeatureFilm
			let time
			if(data <= '00:05:00') {
				time = 'letters-small font-size-8 font-weight-0 m-0'
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-8 font-weight-0', 'font-size-11 font-weight-0 m-0')
			} else if(data > '00:15:00' && data <= '00:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-9 font-weight-0', 'font-size-12 font-weight-0 m-0')
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-12 font-weight-0', 'font-size-14 m-0')
			} else {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-14 font-weight-0', 'font-size-16 m-0')
      }
      //  else {
			// 	time = sizeLetttersAboutProgram(programTitle, 'font-size-16 font-weight-0', 'font-size-18 m-0')
      // }
      //  else {
			// 	time = 'font-size-20 m-0'
      // }
      
			let restructureSize
			if(this.printView  == 'interno' && conditional) {
				restructureSize = (codeFeatureFilm || codeFeatureFilm !== '') && this.counterLettersText(materialTitle) ? 'font-size-12 font-weight-0 m-0' : time
			} else {
				restructureSize = time
			}
			return restructureSize
		},
		counterLettersText(val) {
			let text = val.length
			console.log(text, 'text')
			if( text > 13) {
				return true
			} else {
				return false
			}
		},
		durationProgramResize (val) {
			const {programTitle} = val
			const data = this.calculateTime(val)
			let time
			if(data <= '00:05:00') {
				time = `programSmall`
			} else if (data > '00:05:00' && data <= '00:15:00') {
				time = `programMiddle`
      } 
      else if(data > '00:15:00' && data <= '00:30:00') {
				time = `programRegular`
      }  
      // else {
			// 	time = `programBig`
      // } 
      else {
				time = `programLarge`
			}
			return time
		},
		durationProgramTitleLargometraje(val) {
			const {programTitle} = val
			const data = this.calculateTime(val)
			let time
			if(data <= '00:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-8', 'font-size-9')
			}  else if(data > '00:30:00' && data <= '01:00:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-10', 'font-size-11')
			} else if(data > '01:00:00' && data <= '01:30:00') {
				time = sizeLetttersAboutProgram(programTitle, 'font-size-11', 'font-size-10')
			} else {
				time = 'font-size-13'
			}
			return time
		},
		styleByDurationProgram(val) {
			const {programTitle} = val 
			const time = this.calculateTime(val)
			let style
			if (time <= '00:30:00') {
				style = 'program_small'
			} else if (time > '00:30:00' && time <= '00:45:00') {
				style = 'program_medium'
			} else if (time > '00:45:00' && time <= '01:15:00') {
				style = 'program_normal'
      } 
      else if (time > '01:15:00' && time <= '01:45:00') {
				style = 'program_large'
      }
       else {
				style = 'program_xLarge'
			}
			return style
		},
		isShowActors(data) {
			let response
			const {materialHasChapter, typeOfContent, codeFeatureFilm} = data
			let conditionalType = typeOfContent == 'Largometrajes' || typeOfContent == 'LARGOMETRAJES' ? true : false
			response = conditionalType && materialHasChapter == 'No'? true : false
			return response
		},
		textIsBig(data) {
			let size = String(data)
			let value = size.length >= 11 ? value = `text_ellipsis` : ''
			return value
		}
	},
	created () {
		this.getWeek(this.dateString)
		this.timeForDay = this.formatedArray()
	},
	destroyed () {
		window.removeEventListener('scroll', this.handleScroll);
	},
	watch: {
		orderByProgram(val) {
			if ( val !== [] ) {
				this.fillingGrid(this.orderByProgram)
			}
    	}
	},
}
</script>
<style scoped>
.grid-schedule.resize{
	resize: vertical;
	overflow: auto;
}

.copyPrincipalTitle {
  font-weight: 700;
  text-transform: uppercase;
  text-align: center;
  /* top: 25px !important; */
  /* margin-top: 10px; */
  padding: 0 10px;
  margin-bottom: 5px;
  color: black;
  z-index: 10;
  position: relative;
  width: calc(100% - 21px);
}
.ocupandoContenedor {
  white-space: pre-wrap;
  word-break: break-all;
  word-wrap: break-word;
}
.grid-schedule.resize.o-hidden{overflow: hidden;display:flex;justify-content: center}
.border-none{border:none}
</style>